# MySQL dump 8.13
#
# Host: localhost    Database: chat
#--------------------------------------------------------
# Server version	3.23.36-log

#
# Table structure for table 'bans'
#

CREATE TABLE bans (
  id int(10) NOT NULL auto_increment,
  type enum('user','ip','host') NOT NULL default 'user',
  value varchar(255) NOT NULL default '',
  reason longtext NOT NULL,
  PRIMARY KEY  (id),
  UNIQUE KEY id (id),
  KEY id_2 (id)
) TYPE=MyISAM;


CREATE TABLE chatrooms (
  name varchar(50) NOT NULL default '',
  descr text NOT NULL,
  pos int(11) NOT NULL default '0',
  private tinyint(1) NOT NULL default '0',
  locked tinyint(1) NOT NULL default '0',
  moderate tinyint(1) NOT NULL default '0',
  PRIMARY KEY  (name),
  UNIQUE KEY name_2 (name),
  KEY name (name)
) TYPE=MyISAM;

#
# Dumping data for table 'chatrooms'
#

INSERT INTO chatrooms VALUES ('Lobby','Lets talk!',2,0,0,0);

#
# Table structure for table 'chatusers'
#

CREATE TABLE chatusers (
  nick varchar(20) NOT NULL default '',
  pass varchar(30) NOT NULL default '',
  room varchar(50) NOT NULL default '',
  name varchar(50) NOT NULL default '',
  email varchar(50) NOT NULL default '',
  active tinyint(1) NOT NULL default '0',
  away tinyint(1) NOT NULL default '0',
  mode tinyint(1) NOT NULL default '0',
  lastaction int(20) NOT NULL default '0',
  hpurl varchar(100) NOT NULL default '',
  imgurl varchar(100) NOT NULL default '',
  col varchar(6) NOT NULL default '000000',
  text text NOT NULL,
  guestbook tinyint(1) NOT NULL default '0',
  totaltime int(20) NOT NULL default '0',
  totalmsgs int(20) NOT NULL default '0',
  creation int(20) NOT NULL default '0',
  lastip varchar(15) NOT NULL default '',
  lasthost varchar(100) NOT NULL default '',
  ignorelist longtext NOT NULL,
  sessid varchar(50) NOT NULL default '',
  clearout tinyint(1) NOT NULL default '0',
  connid int(10) NOT NULL default '0',
  PRIMARY KEY  (nick),
  UNIQUE KEY nick_2 (nick,email),
  KEY nick (nick)
) TYPE=MyISAM;

#
# Dumping data for table 'chatusers'
#
INSERT INTO chatusers VALUES ('root','admin','','Admin User','admin@example.com',0,0,9,0,'','','000000','',0,0,0,0,'','','','',0,0);

#
# Table structure for table 'chatusers_gb'
#

CREATE TABLE chatusers_gb (
  owner varchar(20) NOT NULL default '',
  von varchar(20) NOT NULL default '',
  title varchar(255) NOT NULL default '',
  text text NOT NULL,
  date int(15) NOT NULL default 0
) TYPE=MyISAM;

#
# Dumping data for table 'chatusers_gb'
#


#
# Table structure for table 'config'
#

CREATE TABLE config (
  id varchar(50) NOT NULL default '',
  value longtext NOT NULL,
  descr longtext NOT NULL,
  type varchar(20) NOT NULL default '',
  editable enum('yes','no') NOT NULL default 'yes',
  PRIMARY KEY  (id),
  UNIQUE KEY id (id),
  KEY id_2 (id)
) TYPE=MyISAM;

#
# Dumping data for table 'config'
#

INSERT INTO config VALUES ('title','Mazen\'s PHP Chat - V3.0.0 Beta1','The Title of Your Chat','','yes');
INSERT INTO config VALUES ('template','mazenphp','Which Template should be used?','','yes');
INSERT INTO config VALUES ('language','english','The default Language of your Chat','','yes');
INSERT INTO config VALUES ('EMailTitle','Chat-Registration','The Title of the EMail, which is sent to the user after registration.','','yes');
INSERT INTO config VALUES ('MailFrom','automailer@mazenphp.de','Where should the Registration-Mail come from?','','yes');
INSERT INTO config VALUES ('SuccessfullRegistration','Congratulations!<br><br>\r\nYour registration was Successfull. A password has been mailed to you.','Which message Should appear, if the user has been Successfully registered? (It\'s on the Website, not the Email)','','yes');
INSERT INTO config VALUES ('ChatHost','http://','The host the Chatserver runs on. To prevent traffic you should use local ip-addresses if the Chatserver runs on the Same Host as the Webserver','','yes');
INSERT INTO config VALUES ('ServerPort','22223','The Default Port, the Server run\'s on. Should be bigger then 1024.','','yes');
INSERT INTO config VALUES ('BaseURL','http://','The Complete URL to the Chat','','yes');
INSERT INTO config VALUES ('HTTPHost','http://','The Host, the Chat Runs on ','','yes');
INSERT INTO config VALUES ('Smileys','true','Should the Smileys be used ?','bool','yes');
INSERT INTO config VALUES ('OutputHeader','<html><head><title>Mazen\'s PHP-Chat V3.0.0B1</title><style type=\"text/css\"><!-- body	{font-family: Verdana, Arial, Times New Roman; font-size: 10pt;} tr		{font-family: Verdana, Arial, Times New Roman; font-size: 10pt;} td		{font-family: Verdana, Arial, Times New Roman; font-size: 10pt;} th		{font-family: Verdana, Arial, Times New Roman; font-size: 10pt;} table	{font-family: Verdana, Arial, Times New Roman; font-size: 10pt;}  .inputs {	BACKGROUND-COLOR: #eeeeee; BORDER-BOTTOM: #000000 1px solid; BORDER-LEFT: #000000 1px solid; BORDER-RIGHT: #000000 1px solid; BORDER-TOP: #000000 1px solid; COLOR: #000000; FONT-FAMILY: Verdana; FONT-SIZE: 8pt}//--></style></head><body bgcolor=#FFFFFF>','The HTML-Header for the Output-Page','','yes');
INSERT INTO config VALUES ('WelcomeString','Welcome! Have fun in our Chat!<br>','','','yes');
INSERT INTO config VALUES ('SecretKey','Technasia-#MyForceIsMySoUl','This is a Secret Key, which is used when sending the Chatmessages to the Server / Client. Don\'t tell it to anyone!','','yes');
INSERT INTO config VALUES ('CmdLineServer','true','If you are using the command-line server, set this to true. Else set this to false.','bool','yes');
INSERT INTO config VALUES ('EMailBody','Registration information for the Chat:\r\n\r\nUsername: ##USER##\r\nPasswort: ##PASS##\r\n\r\n','This is the EMail-Message containing the registration-information ... \r\n\r\n##USER## is an alias for the Username,\r\n##PASS## is the Passwort','textarea','yes');
INSERT INTO config VALUES ('ChatLog','true','should all Chatmessages be logged ?','bool','yes');

#
# Table structure for table 'msgs'
#

CREATE TABLE msgs (
  datum date NOT NULL default '0000-00-00',
  uhrzeit time NOT NULL default '00:00:00',
  sentby varchar(100) NOT NULL default '',
  sentto varchar(100) NOT NULL default '',
  raum varchar(20) NOT NULL default '',
  message text NOT NULL,
  id int(11) NOT NULL auto_increment,
  PRIMARY KEY  (id),
  UNIQUE KEY id_2 (id),
  KEY id (id)
) TYPE=MyISAM;

#
# Table structure for table 'relayedmsgs'
#

CREATE TABLE relayedmsgs (
  fromuser varchar(20) NOT NULL default '',
  touser varchar(20) NOT NULL default '',
  message longtext NOT NULL
) TYPE=MyISAM;


#
# Table structure for table 'smileys'
#

CREATE TABLE smileys (
  command char(10) NOT NULL default '',
  filename char(30) NOT NULL default '',
  PRIMARY KEY  (command)
) TYPE=MyISAM;

#
# Dumping data for table 'smileys'
#

INSERT INTO smileys VALUES (':bounce:','bounce.gif');
INSERT INTO smileys VALUES (':alien:','aysmile.gif');
INSERT INTO smileys VALUES (':bg:','biggrin.gif');
INSERT INTO smileys VALUES (':sad:','blue.gif');
INSERT INTO smileys VALUES (':clown:','clown.gif');
INSERT INTO smileys VALUES (':conf:','confused.gif');
INSERT INTO smileys VALUES (':cool:','cool.gif');
INSERT INTO smileys VALUES (':cry:','crying.gif');
INSERT INTO smileys VALUES (':dead:','dead.gif');
INSERT INTO smileys VALUES (':devil:','devil.gif');
INSERT INTO smileys VALUES (':eek:','eek.gif');
INSERT INTO smileys VALUES (':embarass:','embarass.gif');
INSERT INTO smileys VALUES (':frown:','frown.gif');
INSERT INTO smileys VALUES (':crazy:','grazy.gif');
INSERT INTO smileys VALUES (':lol:','lol.gif');
INSERT INTO smileys VALUES ('*lol*','lol.gif');
INSERT INTO smileys VALUES (':pukey:','pukey.gif');
INSERT INTO smileys VALUES (':mad:','reallymad.gif');
INSERT INTO smileys VALUES (':blink:','sarcblink.gif');
INSERT INTO smileys VALUES (':sleep:','sleepy.gif');
INSERT INTO smileys VALUES (':)','smile.gif');
INSERT INTO smileys VALUES (':-)','smile.gif');
INSERT INTO smileys VALUES (':smoke:','smokin.gif');
INSERT INTO smileys VALUES (':sg:','sunglasses.gif');
INSERT INTO smileys VALUES (':D','supergrin.gif');
INSERT INTO smileys VALUES (':tasty:','tasty.gif');
INSERT INTO smileys VALUES (':tongue:','tongue.gif');
INSERT INTO smileys VALUES (';)','wink.gif');
INSERT INTO smileys VALUES (':yawn:','yawn.gif');

