<?php
/**
 *
 *  Mazen's PHP Chat Version 3.0.0B1
 *  Chat-Script written in PHP
 *  2001-04-12
 *
 *  Copyright (c) 2001 Marcel Beerta <marcel@beerta.de>
 *
 *
 *  This program is free software; you can redistribute it and/or
 *   modify it under the terms of the GNU General Public License as
 *   published by the Free Software Foundation; either version 2 of
 *   the License, or (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
 *   General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 */


/**
 *   -----------------------------------------------------------------------------------------
 *    Main Index File
 *   -----------------------------------------------------------------------------------------
 */
 
	include "./configuration.inc.php";
	
	
	/* Prepare Some Boxes ... First the Login-Box */
	
	
	/* List of Chatrooms for the Select-Field */
	$result = $db->query("SELECT name,descr,moderate FROM chatrooms WHERE private='0' AND locked='0' ORDER BY pos");
	while($res = $db -> fetch()) {
		$rooms .= "<option value=\"".$res[name]."\">".$res[name];
		if ( $res["moderate"] == 1 ) {
			$rooms .= "(".translate("moderated").")";
		}
	}
	
	$rooms = "<select name=chatroom>".$rooms."</select>";
	
	
	ob_start();
	?>
	<center><b><?= translate("Login"); ?></b></center>
	<form method=POST action="login.php">
	<input type="hidden" name="PHPSESSID" value="<?= $PHPSESSID ?>">
	<table border=0 width=100% cellspacing=0 cellpadding=3>
	<tr>
		<td width=40% align=right><?= translate("Username") ?>:</td>
		<td><input type=text name="user"></td>
	</tr>
	<tr>
		<td align=right><?= translate("Password") ?>:</td>
		<td><input type=password name=password></td>
	</tr>
	<tr>
		<td align=right><?= translate("Chatroom") ?>:</td>
		<td><?= $rooms ?></td>
	</tr>
	<tr>
		<td colspan=2 align=center><input type="submit" value="login"></td>
	</tr>
	</table>
	</form>
	<?php
	
	
	$loginbox = ob_get_contents();
	ob_end_clean();
	
	/** Login Box Ready, now Registration-Box **/
	
	ob_start();
	?>
	<center><b><?= translate("Registration") ?></b></center>
	<form method="POST" action="register.php">
	<input type="hidden" name="PHPSESSID" value="<?= $PHPSESSID ?>">
	<table border=0 width=100% cellspacing=0 cellpadding=3>
	<tr>
		<td width=40% align=right><?= translate("Username") ?>:</td>
		<td><input type=text name=username value="<?= $username ?>"></td>
	</tr>
	<tr>
		<td align=right><?= translate("Real Name") ?>:</td>
		<td><input type=text name=realname value="<?= $realname ?>"></td>
	</tr>
	<tr>
		<td align=right><?= translate("EMail Address") ?>:</td>
		<td><input type=text name=email value="<?= $email ?>"></td>
	</tr>
	<tr>
		<td colspan=2 align=center><input type=reset value="<?= translate("Discard") ?>"> <input type=submit value="<?= translate("Register") ?>"></td>
	</tr>
	</table>
	</form>
	<?php
	$register = ob_get_contents();
	ob_end_clean();
	/* Registration-Box ready ... Now the list of Active Chatrooms/Users */
	
	ob_start();
	?>
		<center><b><?= translate("Chatrooms") ?></b></center>
		<table border=0 width=100% cellspacing=0 cellpadding=3>
		
	<?php
	
	/* Read all Public Chatrooms out of our Database, also, the room shouldn't be locked */
	$result = $db->query("SELECT name,descr,moderate FROM chatrooms WHERE private='0' AND locked='0' ORDER BY pos");
	
	$db2 = new Database($dbhost, $dbuser, $dbpass, $dbname);
	while ($res = $db->fetch()) {
		
		if ($res[moderate] == '1') {
			$roomstring = "<b>".$res[name].":&nbsp;<br> (".translate("Moderated").")</b>&nbsp";
		}
		else $roomstring = "<b>".$res[name]." :</b>&nbsp;";
		?>
		<tr>
			<td width=10% valign=top><?= $roomstring ?></td>
			<td><?= $res[descr] ?></td>
		</tr>
		<?php
		unset($users);
		unset($userlist);
		
		/* Read the Active Chatusers out of our Database ... */
		$result2 = $db2->query("SELECT count(*) as num FROM chatusers WHERE room = '".$res[name]."' AND active='1'");
		$numUsers = $db2 -> fetch();
		$numUsers = $numUsers["num"];
		$result2 = $db2->query("SELECT nick FROM chatusers WHERE room = '".$res[name]."' AND active='1' LIMIT 0, 10");
		while ($res2 = $db2->fetch()) {
			$users[] = $res2[nick];
		}
		if(!empty($users)) {
			for($i=0;$i<sizeof($users);$i++) {
					$userlist .= $users[$i];
					
					$j = $i+1;

					if ( !empty ( $users[$j] ) ) {
						$userlist .= ", ";
					}
					
			}
			if ( sizeof($users) > 10 ) {
				$userlist .= "...";
			}
				
		} else {
			$userlist = "&nbsp;";
		}
			
		?>
		<tr>
			<td><?= $numUsers ?> <?= translate("User(s)"); ?></td>
			<td><?= $userlist ?></td>
		</tr>
	
		<?php
	}
	?>
		</table>
	<?php
	$rooms = ob_get_contents();
	ob_end_clean();
	
	
	/* Finally, we got all blocks and slap them together into our Mainpage ...*/
	$tpl = new IntegratedTemplate("$tplpath/");
	$tpl -> loadTemplateFile("login.html");
	$tpl -> setVariable("TITLE", getConfig("TITLE"));
	$tpl -> setVariable("LOGIN", $loginbox);
	$tpl -> setVariable("REGISTER", $register);
	$tpl -> setVariable("USERLIST", $rooms);
	$tpl -> show();
	

?>
